/*******************************************************************
 * f^VO}ADC@@MCP3911@@SPIgp
 *  PIC24FJ256GA702@FOSC=32MHz
 *@2`l̓d𑪒肵M
 *******************************************************************/
#include <xc.h>
/* RtBM[V̐ݒ */
// FSEC
#pragma config BWRP = OFF               // Boot Segment Write-Protect bit (Boot Segment may be written)
#pragma config BSS = DISABLED           // Boot Segment Code-Protect Level bits (No Protection (other than BWRP))
#pragma config BSEN = OFF               // Boot Segment Control bit (No Boot Segment)
#pragma config GWRP = OFF               // General Segment Write-Protect bit (General Segment may be written)
#pragma config GSS = DISABLED           // General Segment Code-Protect Level bits (No Protection (other than GWRP))
#pragma config CWRP = OFF               // Configuration Segment Write-Protect bit (Configuration Segment may be written)
#pragma config CSS = DISABLED           // Configuration Segment Code-Protect Level bits (No Protection (other than CWRP))
#pragma config AIVTDIS = OFF            // Alternate Interrupt Vector Table bit (Disabled AIVT)
// FBSLIM
#pragma config BSLIM = 0x1FFF           // Boot Segment Flash Page Address Limit bits (Boot Segment Flash page address  limit)
// FSIGN
// FOSCSEL
#pragma config FNOSC = FRCPLL           // Oscillator Source Selection (Fast RC Oscillator with divide-by-N with PLL module (FRCPLL) )
#pragma config PLLMODE = DISABLED       // PLL Mode Selection (No PLL used; PLLEN bit is not available)
#pragma config IESO = OFF               // Two-speed Oscillator Start-up Enable bit (Start up with user-selected oscillator source)
// FOSC
#pragma config POSCMD = NONE            // Primary Oscillator Mode Select bits (Primary Oscillator disabled)
#pragma config OSCIOFCN = OFF           // OSC2 Pin Function bit (OSC2 is clock output)
#pragma config SOSCSEL = ON             // SOSC Power Selection Configuration bits (SOSC is used in crystal (SOSCI/SOSCO) mode)
#pragma config PLLSS = PLL_PRI          // PLL Secondary Selection Configuration bit (PLL is fed by the Primary oscillator)
#pragma config IOL1WAY = OFF            // Peripheral pin select configuration bit (Allow multiple reconfigurations)
#pragma config FCKSM = CSDCMD           // Clock Switching Mode bits (Both Clock switching and Fail-safe Clock Monitor are disabled)
// FWDT
#pragma config WDTPS = PS32768          // Watchdog Timer Postscaler bits (1:32,768)
#pragma config FWPSA = PR128            // Watchdog Timer Prescaler bit (1:128)
#pragma config FWDTEN = OFF             // Watchdog Timer Enable bits (WDT and SWDTEN disabled)
#pragma config WINDIS = OFF             // Watchdog Timer Window Enable bit (Watchdog Timer in Non-Window mode)
#pragma config WDTWIN = WIN25           // Watchdog Timer Window Select bits (WDT Window is 25% of WDT period)
#pragma config WDTCMX = WDTCLK          // WDT MUX Source Select bits (WDT clock source is determined by the WDTCLK Configuration bits)
#pragma config WDTCLK = LPRC            // WDT Clock Source Select bits (WDT uses LPRC)
// FPOR
#pragma config BOREN = ON               // Brown Out Enable bit (Brown Out Enable Bit)
#pragma config LPCFG = OFF              // Low power regulator control (No Retention Sleep)
#pragma config DNVPEN = ENABLE          // Downside Voltage Protection Enable bit (Downside protection enabled using ZPBOR when BOR is inactive)
// FICD
#pragma config ICS = PGD1               // ICD Communication Channel Select bits (Communicate on PGEC1 and PGED1)
#pragma config JTAGEN = OFF             // JTAG Enable bit (JTAG is disabled)
// FDEVOPT1
#pragma config ALTCMPI = DISABLE        // Alternate Comparator Input Enable bit (C1INC, C2INC, and C3INC are on their standard pin locations)
#pragma config TMPRPIN = OFF            // Tamper Pin Enable bit (TMPRN pin function is disabled)
#pragma config SOSCHP = ON              // SOSC High Power Enable bit (valid only when SOSCSEL = 1 (Enable SOSC high power mode (default))
#pragma config ALTI2C1 = ALTI2CEN       // Alternate I2C pin Location (SDA1 and SCL1 on RB9 and RB8)

/**** ϐ`@***/
#define  GreenLED   LATAbits.LATA1
#define  RedLED     LATAbits.LATA0
#define  WhiteLED   LATAbits.LATA2
#define  CS         LATBbits.LATB11         // ADC
#define  RST        LATBbits.LATB15         // ADC
#define  DR         LATBbits.LATB10
#define  Frc    16000000 
/* \bZ[W */
unsigned char SndBuf[] = "CH0=+xxx.xxxxmV, CH1=+xxx.xxxxmV\r\n";
unsigned char buf[6];
double CH0Volt, CH1Volt;
/** ֐vg^CsO */
void GetData(void);
void GetRawData(void);
void SPIOut(unsigned char data);
unsigned char SPIRcv(void);
void Send(unsigned char data1);
void SendStr(unsigned char *buf1);
void SetupMCPADC(unsigned char osr);
void Delayms(unsigned int t);
void itostring(char digit, unsigned int data, unsigned char *buffer);
void ltostring(unsigned char digit, unsigned long data, unsigned char *buffer);
void ftostring(int seisu, int shousu, double data, unsigned char *buffer);

/************ C֐ ********************/
int main(void){
    /* o̓|[gݒ  */
    ANSA = 0;                       // ׂăfW^
    ANSB = 0;
    TRISA = 0x0010;                 //
    TRISB = 0x3797;                 //  
    /* UART1st */
    RPINR18bits.U1RXR = 6;          // UART1 RX to RP6
    RPOR3bits.RP7R = 3;             // UART1 TX to RP7
    /* UART1ݒ@115kbps  */
    U1MODE = 0x8808;                // UART1ݒ BRGH=1
    U1STA =  0x0400;                // UART1ݒ
    U1BRG = 34;                     // 115kbps@16MHz
    /* ԕω荞ݏݒ@ADCDR */
    IOCNBbits.IOCNB10 = 1;          // RP10pin
    IOCSTAT = 0;
    IOCFBbits.IOCFB10 = 0;          // Flag Clear
    PADCONbits.IOCON = 1;           // Enable IOC
    IFS1bits.IOCIF = 0;    
    /* ADC */
    SetupMCPADC(0x3F);              // OSR = 4096
    /****** C[v ******/
    while(1){
        GetData();                              // dlv
        if(CH0Volt < 0){
            SndBuf[4] = '-';
            CH0Volt *= -1;
        }
        else
            SndBuf[4] = '+';
        ftostring(4, 3, CH0Volt, SndBuf+5);     // ɕϊ
        if(CH1Volt < 0){
            SndBuf[21] = '-';
            CH1Volt *= -1;
        }
        else
            SndBuf[21] = '+';
        ftostring(4, 3, CH1Volt, SndBuf+22);    // ɕϊ
        SendStr(SndBuf);                        // PCɑM
        Delayms(2000);
    }
}

/***********************************************************************
 *  f^VO}֐
 *  CH0ACH1ƂQCP@BOOSTI Dither=Max AutoZero=Fast
 *  A/Dϊx@= AMCLK4OSR
 *@Device address = 0
 *  CONFIG1
 *    0x17  AMCLK=16.384MHz OSR=128  -> 32ksps 
 *    0x1F  AMCLK=16.384MHz OSR=256  -> 16ksps
 *    0x27  AMCLK=16.384MHz OSR=512  -> 8ksps
 *    0x2F  AMCLK=16.384MHz OSR=1024 -> 4ksps
 *    0x37  AMCLK=16.384MHz OSR=2048 -> 2ksps
 *    0x3F  AMCLK=16.384MHz OSR=4096 -> 1ksps
************************************************************************/
void SetupMCPADC(unsigned char osr)
{
    /* SPI ADCp*/
    RPINR20bits.SDI1R = 13;         // SDI1 RP13
    RPOR7bits.RP14R = 7;            // SDO1 RP14
    RPOR6bits.RP12R = 8;            // SCK1 RP12
    SPI1CON1L = 0x0320;             // 8bit Master CKE=1 CKP=0  End sample
    SPI1BRGL = 8;                   // 2Mbps
    SPI1CON2L = 0;                  // Frame Disable
    SPI1CON1Lbits.SPIEN = 1;        // SPI enable
    /* Reset ADC */
    RST = 0;            // ADC Reset
    Delayms(1);
    RST = 1;   
    Delayms(1);
    /** Reset ADC **/
    CS = 0;
    SPIOut(0x1A);       // WX^#Dw
    SPIOut(0xC0);       // Reset
    CS = 1;
    /** Configure ADC **/
    CS = 0;
    SPIOut(0x0E);       // WX^#7w
    SPIOut(0x00);       // PHASE1 = 00      Address=0x07
    SPIOut(0x00);       // PHASE2 = 00
    SPIOut(0xC0);       // GAIN = 0xC0, CH0,1Ƃ x1  BOOST Max Gainx8=DB
    SPIOut(0x10);       // STATUSCOM1 = 10, DRL@MOD
    SPIOut(0xBC);       // STATUSCOM2 = B8, READ=10(set) 24bit OFS L@CAL  
    SPIOut(osr);        // CONFIG1 = 3F, AMCLK=MCLK@OSR=512 DITHER=Max AZ=Fast
    SPIOut(0x00);       // CONFIG2 = 00, RST=No SHUT=No VREF=Int CLK=Xtal
    SPIOut(0xFF);       // OFFCAL_CH0 = FF  CH0 Offset Calibration Address=0x0E
    SPIOut(0xF1);       // OFFCAL_CH0 = -7
    SPIOut(0x2C);       // OFFCAL_CH0 = -E0
    SPIOut(0);          // GainCAL CH0 Gain Calibration
    SPIOut(0);
    SPIOut(0);
    SPIOut(0xFF);       // OFFCAL_CH1 = FF   CH1 Offset Calibration Address=0x14
    SPIOut(0xEA);       // OFFCAL_CH1 = +34
    SPIOut(0xF8);       // OFFCAL_CH1 = +80
    CS = 1;
}
/**************************************************
 *  ADC̓dlǂݏo
 *  4oCg畄tlongɂƎۂ̓dɕϊ
 *  ߂l@0Ff[^Ȃ@@0xFFFf[^
 **************************************************/    
void GetData(void){
    int i;
    unsigned long temp;
    signed long temp0, temp1;
    
    while(IFS1bits.IOCIF == 0);    // ADCϊI҂
    /* f[^ */
    i = 0;
    CS = 0;                     // CSANeBu
    SPIOut(0x01);               // WX^#0w̓
    buf[i++] = SPIRcv();        // CH0 ʃoCg
    buf[i++] = SPIRcv();        // CH0 ʃoCg
    buf[i++] = SPIRcv();        // CH0 ʃoCg
    buf[i++] = SPIRcv();        // CH1 ʃoCg
    buf[i++] = SPIRcv();        // CH1 ʃoCg
    buf[i++] = SPIRcv();        // CH1 ʃoCg
    CS = 1;                     // CS    

    /* CH0 char畄tlongɕϊ */    
    i = 0;
    temp = buf[i];                          // ŏʎo
    temp = (temp << 8) | buf[i+1];          // ʎo
    temp = (temp << 8) | buf[i+2];          // ʎo
    temp = temp << 8;                       // 4oCglong
    temp0 = (signed long)temp;              // t3oCgɖ߂
    temp0 /= 256;
    CH0Volt = (double)(temp0*800.0)/0x7FFFFF;      // ۂ̓dɕϊ
    /* CH1 char畄tlongɕϊ */
    temp = buf[i+3];                        // ŏʎo
    temp = (temp << 8) | buf[i+4];
    temp = (temp << 8) | buf[i+5];
    temp = temp << 8;                       // 4oCglong
    temp1 = (signed long)temp;              // t3oCgɖ߂
    temp1 /= 256;
    CH1Volt = (double)(temp1*800.0)/0x7FFFFF;      // ۂ̓dɕϊ  
    IFS1bits.IOCIF = 0;    
}  
/*********************************
* SPI1oCgo
**********************************/
void SPIOut(unsigned char data){
    unsigned char dumy;
      
    while(SPI1STATLbits.SPITBF);        // MfB[`FbN
    SPI1BUFL = data;                    // f[^M
    while(SPI1STATLbits.SPIRBF==0);     // M҂
    dumy = SPI1BUFL;                    // _~[M
}
/********************************
* SPI1oCg
********************************/
unsigned char SPIRcv(void){
    while(SPI1STATLbits.SPITBF);        // MfB[`FbN
    SPI1BUFL = 0xAA;                    // _~[f[^M
    while(SPI1STATLbits.SPIRBF == 0);   // M҂
    return(SPI1BUFL);                   // Mf[^Ԃ
}
/***************************************************
 * 1msecx֐@^C}2gp Fosc=16MHz
 ***************************************************/
void Delayms(unsigned int t){
    IFS0bits.T2IF = 0;              // 荞݃tONA
    PR2 = 250;                      // 1msecݒ
    T2CON = 0x8020;                 // ^C}4X^[g@vXP[ 1/64
    while (t--) {                   // JԂ
        while (!IFS0bits.T2IF);     // ҂
        IFS0bits.T2IF = 0;          // 荞݃tONA
    }
}
/********************************
 * UART1 MsTu֐
 ********************************/
void Send(unsigned char data1){
    while(!U1STAbits.TRMT);              // MfB[҂
    U1TXREG = data1;                     // Ms
}
/*******************************************
 * UART1񑗐M֐
 *******************************************/
void SendStr(unsigned char * buf1)
{
    while(*buf1 != 0){                   // ̏I܂
        Send(*buf1++);                   // 
    }
}
/**************************************
 *  l當ɕϊ
 * ***********************************/
void itostring(char digit, unsigned int data, unsigned char *buffer)
{
    int i;

    buffer += digit;                    // ̍Ō
    for(i=digit; i>0; i--) {            // ŉʌʂ
        buffer--;                       // |C^[P
        *buffer = (data % 10) + '0';    // ̌l𕶎ɂĊi[
        data = data / 10;               // -1
    }
}
/***************************************
* longASCIIɕϊ
****************************************/
void ltostring(unsigned char digit, unsigned long data, unsigned char *buffer){
    unsigned char i;

    buffer += digit;                        // Ō̐ʒu
    for(i=digit; i>0; i--) {                // ϊ͉ʂʂ
        buffer--;                           // |C^[P
        *buffer = (data % 10) + '0';        // ASCII
        data = data / 10;                   // ̌
    }
}
/***********************************
* Float當֕ϊ
* vL8ȉƂ邱
***********************************/
void ftostring(int seisu, int shousu, double data, unsigned char *buffer)
{
    int i;
    long dumy;

    if(shousu != 0)                         //肩
        buffer += seisu+shousu+1;           //Š{_
    else                                    //Ȃ̂Ƃ
        buffer += seisu + shousu;           //Š̂
    buffer--;                               //z|C^-1
    for(i=0; i<shousu; i++)                 //𐮐ɕϊ
        data = data * 10;                   //PO{
    /* dumyI[o[t[ƕϊs(WE) */
    dumy = (long) (data + 0.5);             //ľܓĐɕϊ
    for(i=shousu; i>0; i--) {               //JԂ
        *buffer =(dumy % 10)+'0';           //l𕶎ɕϊi[
        buffer--;                           //i[ꏊʂʂ
        dumy /= 10;                         //̌
    }
    if(shousu != 0) {                       //0Ȃ珬_Ȃ
        *buffer = '.';                      //_i[
        buffer--;                           //|C^-1
    }
    for(i=seisu; i>0; i--) {                //JԂ
        *buffer = (dumy % 10)+'0';          //l𕶎ɕϊi[
        buffer--;                           //|C^-1
        dumy /= 10;                         //̌
    }
}
    