/*******************************************************************
 * xZT@@ADXL345@@SPIgp
 *  PIC24FJ256GA702@FOSC=32MHz
 *@XAYAZ3̉xvPCɑM
 *******************************************************************/
#include <xc.h>
/* RtBM[V̐ݒ */
// FSEC
#pragma config BWRP = OFF               // Boot Segment Write-Protect bit (Boot Segment may be written)
#pragma config BSS = DISABLED           // Boot Segment Code-Protect Level bits (No Protection (other than BWRP))
#pragma config BSEN = OFF               // Boot Segment Control bit (No Boot Segment)
#pragma config GWRP = OFF               // General Segment Write-Protect bit (General Segment may be written)
#pragma config GSS = DISABLED           // General Segment Code-Protect Level bits (No Protection (other than GWRP))
#pragma config CWRP = OFF               // Configuration Segment Write-Protect bit (Configuration Segment may be written)
#pragma config CSS = DISABLED           // Configuration Segment Code-Protect Level bits (No Protection (other than CWRP))
#pragma config AIVTDIS = OFF            // Alternate Interrupt Vector Table bit (Disabled AIVT)
// FBSLIM
#pragma config BSLIM = 0x1FFF           // Boot Segment Flash Page Address Limit bits (Boot Segment Flash page address  limit)
// FSIGN
// FOSCSEL
#pragma config FNOSC = FRCPLL           // Oscillator Source Selection (Fast RC Oscillator with divide-by-N with PLL module (FRCPLL) )
#pragma config PLLMODE = DISABLED       // PLL Mode Selection (No PLL used; PLLEN bit is not available)
#pragma config IESO = OFF               // Two-speed Oscillator Start-up Enable bit (Start up with user-selected oscillator source)
// FOSC
#pragma config POSCMD = NONE            // Primary Oscillator Mode Select bits (Primary Oscillator disabled)
#pragma config OSCIOFCN = OFF           // OSC2 Pin Function bit (OSC2 is clock output)
#pragma config SOSCSEL = ON             // SOSC Power Selection Configuration bits (SOSC is used in crystal (SOSCI/SOSCO) mode)
#pragma config PLLSS = PLL_PRI          // PLL Secondary Selection Configuration bit (PLL is fed by the Primary oscillator)
#pragma config IOL1WAY = OFF            // Peripheral pin select configuration bit (Allow multiple reconfigurations)
#pragma config FCKSM = CSDCMD           // Clock Switching Mode bits (Both Clock switching and Fail-safe Clock Monitor are disabled)
// FWDT
#pragma config WDTPS = PS32768          // Watchdog Timer Postscaler bits (1:32,768)
#pragma config FWPSA = PR128            // Watchdog Timer Prescaler bit (1:128)
#pragma config FWDTEN = OFF             // Watchdog Timer Enable bits (WDT and SWDTEN disabled)
#pragma config WINDIS = OFF             // Watchdog Timer Window Enable bit (Watchdog Timer in Non-Window mode)
#pragma config WDTWIN = WIN25           // Watchdog Timer Window Select bits (WDT Window is 25% of WDT period)
#pragma config WDTCMX = WDTCLK          // WDT MUX Source Select bits (WDT clock source is determined by the WDTCLK Configuration bits)
#pragma config WDTCLK = LPRC            // WDT Clock Source Select bits (WDT uses LPRC)
// FPOR
#pragma config BOREN = ON               // Brown Out Enable bit (Brown Out Enable Bit)
#pragma config LPCFG = OFF              // Low power regulator control (No Retention Sleep)
#pragma config DNVPEN = ENABLE          // Downside Voltage Protection Enable bit (Downside protection enabled using ZPBOR when BOR is inactive)
// FICD
#pragma config ICS = PGD1               // ICD Communication Channel Select bits (Communicate on PGEC1 and PGED1)
#pragma config JTAGEN = OFF             // JTAG Enable bit (JTAG is disabled)
// FDEVOPT1
#pragma config ALTCMPI = DISABLE        // Alternate Comparator Input Enable bit (C1INC, C2INC, and C3INC are on their standard pin locations)
#pragma config TMPRPIN = OFF            // Tamper Pin Enable bit (TMPRN pin function is disabled)
#pragma config SOSCHP = ON              // SOSC High Power Enable bit (valid only when SOSCSEL = 1 (Enable SOSC high power mode (default))
#pragma config ALTI2C1 = ALTI2CEN       // Alternate I2C pin Location (SDA1 and SCL1 on RB9 and RB8)

/**** ϐ`@***/
#define  CS         LATBbits.LATB11
/* \bZ[W */
unsigned char SndBuf[] = "X=+xxxx, Y=+xxxx, Z=+xxxx \r\n";
int Xdata, Ydata, Zdata;
/** ֐vg^CsO */
void AccelInit(void);
void GetAccel(void);
void SPICmd(unsigned char adrs, unsigned char data);
void GetSPIData(unsigned char adrs, unsigned char *buf,unsigned char cnt);
void SPIOut(unsigned char data);
unsigned char SPIRcv(void);
void Send(unsigned char data1);
void SendStr(unsigned char *buf1);
void SetupMCPADC(unsigned char osr);
void Delayms(unsigned int t);
void itostring(char digit, unsigned int data, unsigned char *buffer);
void ltostring(unsigned char digit, unsigned long data, unsigned char *buffer);
void ftostring(int seisu, int shousu, double data, unsigned char *buffer);

/************ C֐ ********************/
int main(void){
    /* o̓|[gݒ  */
    ANSA = 0;                       // ׂăfW^
    ANSB = 0;
    TRISA = 0x0010;                 //
    TRISB = 0x3397;                 //  
    /* UART1st */
    RPINR18bits.U1RXR = 6;          // UART1 RX to RP6
    RPOR3bits.RP7R = 3;             // UART1 TX to RP7
    /* UART1ݒ@115kbps  */
    U1MODE = 0x8808;                // UART1ݒ BRGH=1
    U1STA =  0x0400;                // UART1ݒ
    U1BRG = 34;                     // 115kbps@16MHz
    /* ZT */
    AccelInit();
    /****** C[v ******/
    while(1){
        GetAccel();                     // xlǂݏo
        SndBuf[2] = ' ';                // Xf[^𕶎ɕϊ
        if(Xdata < 0){                  // f[^̏ꍇ
            Xdata *= -1;                // ̒lɂ
            SndBuf[3] = '-';            // -L
        }
        itostring(4, Xdata, SndBuf+3);  // 
        SndBuf[11] = ' ';               // Yf[^𕶎ɕϊ
        if(Ydata < 0){                  // Y̏ꍇ
            Ydata *= -1;                // ɂ
            SndBuf[11] = '-';           // -L
        }
        itostring(4, Ydata, SndBuf+12); // 
        SndBuf[20] = ' ';               // Z𕶎ɕϊ
        if(Zdata < 0){                  // ̏ꍇ
            Zdata *= -1;                // ɂ
            SndBuf[21] = '-';           // -L
        }
        itostring(4, Zdata, SndBuf+21); //  
        SendStr(SndBuf);                // PCɑM
        Delayms(1000);
    }
}
/**********************************************
 *  xZT֐
 *  10rbg[hFIFOȂ
***********************************************/
void AccelInit(void)
{
    /* SPI */
    CS = 1;
    RPINR20bits.SDI1R = 13;         // SDI1 RP13
    RPOR7bits.RP14R = 7;            // SDO1 RP14
    RPOR6bits.RP12R = 8;            // SCK1 RP12
    SPI1CON1L = 0x0060;             // 8bit Master CKE=0 CKP=1  Mid sample
    SPI1BRGL = 32;                  // 500kbps
    SPI1CON2L = 0;                  // Frame Disable
    SPI1CON1Lbits.SPIEN = 1;        // SPI enable
    /* ZTݒR}hM */
    SPICmd(0x2C, 0x0A);             // Power On, 100Hz
    SPICmd(0x31, 0);                // SPI Data_Format 10bit Right 2g
    SPICmd(0x38, 0);                // FIFO mode ByPass
    SPICmd(0x2D, 0x08);             // Mesure mode
    Delayms(5);
}
/**************************************************
 * xlǂݏo
 * O[oϐ XdataAYdataAZdataɊi[ 
 * WX^AhX̏ʃrbg@DB7=1@DB6=1
 **************************************************/    
void GetAccel(void){
    union{
        unsigned char buf[6];
        int ibuf[3];
    }data;
    /* f[^ Read/Multi Bytes */
    GetSPIData(0xF2, &data.buf[0], 6);           // 0x32+0xC0 
    /* f[^ϊ */
    Xdata = data.ibuf[0];
    Ydata = data.ibuf[1];
    Zdata = data.ibuf[2];      
}
/****************************************
 *  SPIŃR}ho
 * @WX^AhX DB7=0@DB6=0
 ***************************************/
void SPICmd(unsigned char adrs, unsigned char data){
    CS = 0;
    SPIOut(adrs);       // WX^AhX
    SPIOut(data);       // ݒf[^
    CS = 1;
}
/********************************
 * SPIŘAf[^M
 ********************************/
void GetSPIData(unsigned char adrs, unsigned char *buf,unsigned char cnt){
    int j;
    
    CS = 0;
    SPIOut(adrs);           // WX^AhX
    for(j=0; j<cnt; j++){   // JԂ
        *buf = SPIRcv();    // 1oCgM
        buf++;              // |C^XV
    }
    CS = 1;
}
/*********************************
* SPI1oCgo
**********************************/
void SPIOut(unsigned char data){
    unsigned char dumy;
      
    while(SPI1STATLbits.SPITBF);        // MfB[`FbN
    SPI1BUFL = data;                    // f[^M
    while(SPI1STATLbits.SPIRBF==0);     // M҂
    dumy = SPI1BUFL;                    // _~[M
}
/********************************
* SPI1oCg
********************************/
unsigned char SPIRcv(void){
    while(SPI1STATLbits.SPITBF);        // MfB[`FbN
    SPI1BUFL = 0xAA;                    // _~[f[^M
    while(SPI1STATLbits.SPIRBF == 0);   // M҂
    return(SPI1BUFL);                   // Mf[^Ԃ
}
/***************************************************
 * 1msecx֐@^C}2gp Fosc=16MHz
 ***************************************************/
void Delayms(unsigned int t){
    IFS0bits.T2IF = 0;              // 荞݃tONA
    PR2 = 250;                      // 1msecݒ
    T2CON = 0x8020;                 // ^C}4X^[g@vXP[ 1/64
    while (t--) {                   // JԂ
        while (!IFS0bits.T2IF);     // ҂
        IFS0bits.T2IF = 0;          // 荞݃tONA
    }
}
/********************************
 * UART1 MsTu֐
 ********************************/
void Send(unsigned char data1){
    while(!U1STAbits.TRMT);              // MfB[҂
    U1TXREG = data1;                     // Ms
}
/*******************************************
 * UART1񑗐M֐
 *******************************************/
void SendStr(unsigned char * buf1)
{
    while(*buf1 != 0){                   // ̏I܂
        Send(*buf1++);                   // 
    }
}
/**************************************
 *  l當ɕϊ
 * ***********************************/
void itostring(char digit, unsigned int data, unsigned char *buffer)
{
    int i;

    buffer += digit;                    // ̍Ō
    for(i=digit; i>0; i--) {            // ŉʌʂ
        buffer--;                       // |C^[P
        *buffer = (data % 10) + '0';    // ̌l𕶎ɂĊi[
        data = data / 10;               // -1
    }
}
/***************************************
* longASCIIɕϊ
****************************************/
void ltostring(unsigned char digit, unsigned long data, unsigned char *buffer){
    unsigned char i;

    buffer += digit;                        // Ō̐ʒu
    for(i=digit; i>0; i--) {                // ϊ͉ʂʂ
        buffer--;                           // |C^[P
        *buffer = (data % 10) + '0';        // ASCII
        data = data / 10;                   // ̌
    }
}
/***********************************
* Float當֕ϊ
* vL8ȉƂ邱
***********************************/
void ftostring(int seisu, int shousu, double data, unsigned char *buffer)
{
    int i;
    long dumy;

    if(shousu != 0)                         //肩
        buffer += seisu+shousu+1;           //Š{_
    else                                    //Ȃ̂Ƃ
        buffer += seisu + shousu;           //Š̂
    buffer--;                               //z|C^-1
    for(i=0; i<shousu; i++)                 //𐮐ɕϊ
        data = data * 10;                   //PO{
    /* dumyI[o[t[ƕϊs(WE) */
    dumy = (long) (data + 0.5);             //ľܓĐɕϊ
    for(i=shousu; i>0; i--) {               //JԂ
        *buffer =(dumy % 10)+'0';           //l𕶎ɕϊi[
        buffer--;                           //i[ꏊʂʂ
        dumy /= 10;                         //̌
    }
    if(shousu != 0) {                       //0Ȃ珬_Ȃ
        *buffer = '.';                      //_i[
        buffer--;                           //|C^-1
    }
    for(i=seisu; i>0; i--) {                //JԂ
        *buffer = (dumy % 10)+'0';          //l𕶎ɕϊi[
        buffer--;                           //|C^-1
        dumy /= 10;                         //̌
    }
}
    