/*******************************************************************
 * EFU[ZT@@BME280@@SPIgp
 *  PIC24FJ256GA702@FOSC=32MHz
 *@xAxAC𕶎ɂPCɑM
 *******************************************************************/
#include <xc.h>
/* RtBM[V̐ݒ */
// FSEC
#pragma config BWRP = OFF               // Boot Segment Write-Protect bit (Boot Segment may be written)
#pragma config BSS = DISABLED           // Boot Segment Code-Protect Level bits (No Protection (other than BWRP))
#pragma config BSEN = OFF               // Boot Segment Control bit (No Boot Segment)
#pragma config GWRP = OFF               // General Segment Write-Protect bit (General Segment may be written)
#pragma config GSS = DISABLED           // General Segment Code-Protect Level bits (No Protection (other than GWRP))
#pragma config CWRP = OFF               // Configuration Segment Write-Protect bit (Configuration Segment may be written)
#pragma config CSS = DISABLED           // Configuration Segment Code-Protect Level bits (No Protection (other than CWRP))
#pragma config AIVTDIS = OFF            // Alternate Interrupt Vector Table bit (Disabled AIVT)
// FBSLIM
#pragma config BSLIM = 0x1FFF           // Boot Segment Flash Page Address Limit bits (Boot Segment Flash page address  limit)
// FSIGN
// FOSCSEL
#pragma config FNOSC = FRCPLL           // Oscillator Source Selection (Fast RC Oscillator with divide-by-N with PLL module (FRCPLL) )
#pragma config PLLMODE = DISABLED       // PLL Mode Selection (No PLL used; PLLEN bit is not available)
#pragma config IESO = OFF               // Two-speed Oscillator Start-up Enable bit (Start up with user-selected oscillator source)
// FOSC
#pragma config POSCMD = NONE            // Primary Oscillator Mode Select bits (Primary Oscillator disabled)
#pragma config OSCIOFCN = OFF           // OSC2 Pin Function bit (OSC2 is clock output)
#pragma config SOSCSEL = ON             // SOSC Power Selection Configuration bits (SOSC is used in crystal (SOSCI/SOSCO) mode)
#pragma config PLLSS = PLL_PRI          // PLL Secondary Selection Configuration bit (PLL is fed by the Primary oscillator)
#pragma config IOL1WAY = OFF            // Peripheral pin select configuration bit (Allow multiple reconfigurations)
#pragma config FCKSM = CSDCMD           // Clock Switching Mode bits (Both Clock switching and Fail-safe Clock Monitor are disabled)
// FWDT
#pragma config WDTPS = PS32768          // Watchdog Timer Postscaler bits (1:32,768)
#pragma config FWPSA = PR128            // Watchdog Timer Prescaler bit (1:128)
#pragma config FWDTEN = OFF             // Watchdog Timer Enable bits (WDT and SWDTEN disabled)
#pragma config WINDIS = OFF             // Watchdog Timer Window Enable bit (Watchdog Timer in Non-Window mode)
#pragma config WDTWIN = WIN25           // Watchdog Timer Window Select bits (WDT Window is 25% of WDT period)
#pragma config WDTCMX = WDTCLK          // WDT MUX Source Select bits (WDT clock source is determined by the WDTCLK Configuration bits)
#pragma config WDTCLK = LPRC            // WDT Clock Source Select bits (WDT uses LPRC)
// FPOR
#pragma config BOREN = ON               // Brown Out Enable bit (Brown Out Enable Bit)
#pragma config LPCFG = OFF              // Low power regulator control (No Retention Sleep)
#pragma config DNVPEN = ENABLE          // Downside Voltage Protection Enable bit (Downside protection enabled using ZPBOR when BOR is inactive)
// FICD
#pragma config ICS = PGD1               // ICD Communication Channel Select bits (Communicate on PGEC1 and PGED1)
#pragma config JTAGEN = OFF             // JTAG Enable bit (JTAG is disabled)
// FDEVOPT1
#pragma config ALTCMPI = DISABLE        // Alternate Comparator Input Enable bit (C1INC, C2INC, and C3INC are on their standard pin locations)
#pragma config TMPRPIN = OFF            // Tamper Pin Enable bit (TMPRN pin function is disabled)
#pragma config SOSCHP = ON              // SOSC High Power Enable bit (valid only when SOSCSEL = 1 (Enable SOSC high power mode (default))
#pragma config ALTI2C1 = ALTI2CEN       // Alternate I2C pin Location (SDA1 and SCL1 on RB9 and RB8)

/**** ϐ`@***/
typedef   unsigned long uint32;
typedef    signed long  int32;
#define  LED   LATBbits.LATB5
#define  CS    LATBbits.LATB11

/* \bZ[W */
unsigned char SendBuf[] = "Temp=+xx.xx, Humi=xx.x, Pres=xxxx.x\r\n";
/** 茋ʃf[^ ***/
int32 t_fine;
/** rpϐf[^ **/
unsigned int T1;
int  T2, T3;
unsigned int P1;
int  P2, P3, P4, P5, P6, P7, P8, P9;
unsigned int H1, H3;
int  H2, H4, H5, H6;
/** ʃf[^ **/
double temp_act, pres_act, hum_act, dumy;


/** ֐vg^CsO */
void BMEInit(void);
void GetBMETrim(void);
void GetBMEData(void);
int32 calib_temp(int32 adc_T);
uint32 calib_pres(int32 adc_P);
uint32 calib_hum(int32 adc_H);
void Send(unsigned char data1);
void SendStr(unsigned char *buf1);
void SPIOut(unsigned char data);
void SPICmd(unsigned char adrs, unsigned char data);
void GetSPIData(unsigned char adrs, unsigned char *buf,unsigned char cnt);
unsigned char SPIRcv(void);
void Delay100ms(unsigned int t);
void itostring(char digit, unsigned int data, unsigned char *buffer);
void ltostring(unsigned char digit, unsigned long data, unsigned char *buffer);
void ftostring(int seisu, int shousu, double data, unsigned char *buffer);

/************ C֐ ********************/
int main(void){
    /* o̓|[gݒ  */
    ANSA = 0;                       // ׂăfW^
    ANSB = 0;
    TRISA = 0x0010;                 //
    TRISB = 0x2097;                 //  
    /* UART1st */
    RPINR18bits.U1RXR = 6;          // UART1 RX to RP6
    RPOR3bits.RP7R = 3;             // UART1 TX to RP7
    /* UART1ݒ@115kbps  */
    U1MODE = 0x8808;                // UART1ݒ BRGH=1
    U1STA =  0x0400;                // UART1ݒ
    U1BRG = 34;                     // 115kbps@16MHz
    /** BME **/
    BMEInit();                      // ݒ 
    GetBMETrim();                   // ␳pf[^擾
    /****** C[v ******/
    while(1){
        /*** xZTf[^擾  ***/
        GetBMEData();                               // vf[^擾
        /*** el̕f[^ւ̕ϊƑM ****/                
        if(temp_act < 0){                           // x̏ꍇ
            dumy = temp_act * -1.0;                 // ɕϊ
            SendBuf[5] = '-';                       // ۑ
        }
        else{                                       // x̏ꍇ
            dumy = temp_act;                        // ̂܂
            SendBuf[5] = ' ';                       // Xy[Xۑ
        }
        ftostring(2, 2, dumy, SendBuf+6);           // x𕶎ɕϊ@xx.xx
        ftostring(2, 1, hum_act, SendBuf+18);       // x𕶎ɕϊ xx.x
        ftostring(4, 1, pres_act, SendBuf+29);      // C𕶎ɕϊ xxxx.x            
        SendStr(SendBuf);                           // PCɑM
        Delay100ms(20);                             // 2sec wait
    }
}
/************************************************************
 *  BME֐ [hݒ
 *  0xF2  ctrl_hum_reg   0000 0001  Oversample=1    
 *  0xF4  ctrl_meas_reg  0010 0111  Mode=11(Normal)
 *  0xF5  config_reg     1010 0000  stndby=1sec IIR-0 I2C
 *  ݂̏ꍇ̓AhX̍ŏʃrbg0ɂKv 
 ************************************************************/
void BMEInit(void){
    /* SPI */
    RPINR20bits.SDI1R = 13;         // SDI1 RP13
    RPOR7bits.RP14R = 7;            // SDO1 RP14
    RPOR6bits.RP12R = 8;            // SCK1 RP12
    SPI1CON1L = 0x0260;             // 8bit Master CKE=0 CKP=1  End sample
    SPI1BRGL = 8;                   // 2Mbps
    SPI1CON2L = 0;                  // Frame Disable
    SPI1CON1Lbits.SPIEN = 1;        // SPI enable    
    /** Reset **/
    SPICmd(0x60, 0xB6);             // reset
    /** ZTݒ **/
    SPICmd(0x72, 0x01);             // Ctrl_hum_reg
    SPICmd(0x74, 0x27);             // Ctrl_meas_reg
    SPICmd(0x75, 0xA0);             // config/reg
}
/*********************************************************
 * rpf[^擾      ꎞobt@:buf
 * ǂݏȍꍇ̓AhX̍ŏʃrbg1ɂ
 ********************************************************/
void GetBMETrim(void){
    unsigned char buf[40];
    
    /*** rf[^o ***/
    GetSPIData(0x88, buf, 24);          // Get from 0x88 to 0x9F
    GetSPIData(0xA1, buf+24, 1);        // Get 0xA1
    GetSPIData(0xE1, buf+25, 7);        // Get from 0xE1 to E7
    /** 16rbgf[^ɕϊ **/
    T1 = (unsigned int)((buf[1] << 8) | buf[0]);
    T2 = (int)((buf[3] << 8) | buf[2]);
    T3 = (int)((buf[5] << 8) | buf[4]);
    P1 = (unsigned int)((buf[7] << 8) | buf[6]);
    P2 = (int)((buf[9] << 8) | buf[8]);
    P3 = (int)((buf[11] << 8) | buf[10]);
    P4 = (int)((buf[13] << 8) | buf[12]);
    P5 = (int)((buf[15] << 8) | buf[14]);
    P6 = (int)((buf[17] << 8) | buf[16]);
    P7 = (int)((buf[19] << 8) | buf[18]);
    P8 = (int)((buf[21] << 8) | buf[20]);
    P9 = (int)((buf[23] << 8) | buf[22]);
    H1 = (unsigned int)buf[24];
    H2 = (int)((buf[26] << 8) | buf[25]);
    H3 = (unsigned int)buf[27];
    H4 = (int)((buf[28] << 4) | (0x0F & buf[29]));
    H5 = (int)((buf[30] << 4) | ((buf[29] >> 4) & 0x0F));
    H6 = (int)buf[31];
}
/**************************************
 *  f[^o
 **************************************/
void GetBMEData(void){
    unsigned char buf[8];
    uint32 hum_raw, temp_raw, pres_raw, pres_cal, hum_cal;    
    int32 temp_cal;
    
    GetSPIData(0xF7, buf, 8);           // Get from 0xF7 to 0xFE
    /** e32rbgf[^ɕϊ **/
    pres_raw = (uint32)(((uint32)buf[0] << 12) + ((uint32)buf[1] << 4) + ((uint32)buf[2] >> 4));
    temp_raw = (uint32)(((uint32)buf[3] << 12) + ((uint32)buf[4] << 4) + ((uint32)buf[5] >> 4));
    hum_raw  = (uint32)(((uint32)buf[6] << 8) + (uint32)buf[7]);
    /*** el̕␳ ***/
    temp_cal = calib_temp(temp_raw);            // x␳
    pres_cal = calib_pres(pres_raw);            // C␳
    hum_cal = calib_hum(hum_raw);               // x␳
    /*** ۂ̒lɃXP[ϊ **/
    temp_act = (double)temp_cal / 100.0;        // x
    pres_act = (double)pres_cal / 100.0;        // C
    hum_act = (double)hum_cal / 1024.0;         // x    
}
/**************************************
 * x̕␳
 **************************************/
int32 calib_temp(int32 adc_T){
    int32 var1, var2, T;
    
    var1 = ((((adc_T >> 3) - ((int32)T1 << 1))) *((int32)T2)) >> 11;
    var2 = (((((adc_T >> 4) - ((int32)T1)) *((adc_T >> 4)-((int32)T1))) >> 12) *((int32)T3)) >> 14;
    t_fine = var1 + var2;
    T = (t_fine * 5 + 128) >> 8;
    return T;
}
/*********************************
 * C̕␳
 *********************************/
uint32 calib_pres(int32 adc_P){
    int32 var1, var2;
    uint32 P;
    
    var1 = (t_fine >> 1) - (int32)64000;
    var2 = (((var1 >> 2) * (var1 >> 2)) >>11) * (int32)P6;
    var2 = var2 + ((var1 * (int32)P5) << 1);
    var2 = (var2 >> 2) + ((int32)P4 << 16);
    var1 = ((((int32)P3 * (((var1 >> 2)*(var1 >> 2)) >> 13)) >> 3) + (((int32)P2 * var1)>>1)) >> 18;
    var1 = (((int32)32768 + var1) * (int32)P1) >> 15;
    if(var1 == 0)
        return 0;
    P = ((uint32)(((int32)1048576 - adc_P) - (var2 >> 12))) * 3125;
    if(P < 0x80000000)
        P = (P << 1) / (uint32)var1;
    else
        P = (P / (uint32)var1) * 2;
    var1 = (P9 * ((int32)(((P >> 3) * (P >> 3)) >> 13))) >> 12;
    var2 = (((int32)(P >> 2)) * (int32)P8) >> 13;
    P = (uint32)((int32)P + ((var1 + var2 + (int32)P7) >> 4));
    return P;    
}
/**************************
 * x̕␳
 ***************************/
uint32 calib_hum(int32 adc_H){
    int32 v_x1;
    
    v_x1 = (t_fine - ((int32)76800));
    v_x1 = (((((adc_H << 14) - (((int32)H4) << 20) - (((int32)H5) * v_x1))+
            ((int32)16384)) >> 15) * (((((((v_x1 * ((int32)H6)) >> 10) *
            (((v_x1 * ((int32)H3)) >>11) + ((int32)32768))) >> 10) + 
            ((int32)2097152)) * ((int32)H2) + 8192) >> 14));
    v_x1 = (v_x1 - (((((v_x1 >> 15) * (v_x1 >> 15)) >> 7) * ((int32)H1)) >> 4));
    if(v_x1 < 0)
        v_x1 = 0;
    if(v_x1 > 419430400)
        v_x1 = 419430400;
    return (uint32)(v_x1 >> 12);
}
/********************************
 *  SPIŃR}ho
 ********************************/
void SPICmd(unsigned char adrs, unsigned char data){
    CS = 0;
    SPIOut(adrs);       // WX^AhX
    SPIOut(data);       // ݒf[^
    CS = 1;
}
/********************************
 * SPIŘAf[^M
 ********************************/
void GetSPIData(unsigned char adrs, unsigned char *buf,unsigned char cnt){
    int j;
    
    CS = 0;
    SPIOut(adrs);           // WX^AhX
    for(j=0; j<cnt; j++){   // JԂ
        *buf = SPIRcv();    // 1oCgM
        buf++;              // |C^XV
    }
    CS = 1;
}
/*********************************
* SPI1oCgo
**********************************/
void SPIOut(unsigned char data){
    unsigned char dumy;
      
    while(SPI1STATLbits.SPITBF);        // MfB[`FbN
    SPI1BUFL = data;                    // f[^M
    while(SPI1STATLbits.SPIRBF==0);     // M҂
    dumy = SPI1BUFL;                    // _~[M
}

/********************************
* SPI1oCg
********************************/
unsigned char SPIRcv(void){
    while(SPI1STATLbits.SPITBF);        // MfB[`FbN
    SPI1BUFL = 0xAA;                    // _~[f[^M
    while(SPI1STATLbits.SPIRBF == 0);   // M҂
    return(SPI1BUFL);                   // Mf[^Ԃ
}
/***************************************************
 * 100msecx֐@^C}2gp Fosc=16MHz
 ***************************************************/
void Delay100ms(unsigned int t){
    IFS0bits.T2IF = 0;              // 荞݃tONA
    PR2 = 25000;                     // 100msecݒ
    T2CON = 0x8020;                 // ^C}4X^[g@vXP[ 1/64
    while (t--) {                   // JԂ
        while (!IFS0bits.T2IF);     // ҂
        IFS0bits.T2IF = 0;          // 荞݃tONA
    }
}
/********************************
 * UART1 MsTu֐
 ********************************/
void Send(unsigned char data1){
    while(!U1STAbits.TRMT);              // MfB[҂
    U1TXREG = data1;                     // Ms
}
/*******************************************
 * UART1񑗐M֐
 *******************************************/
void SendStr(unsigned char * buf1)
{
    while(*buf1 != 0){                   // ̏I܂
        Send(*buf1++);                   // 
    }
}
/**************************************
 *  l當ɕϊ
 * ***********************************/
void itostring(char digit, unsigned int data, unsigned char *buffer)
{
    int i;

    buffer += digit;                    // ̍Ō
    for(i=digit; i>0; i--) {            // ŉʌʂ
        buffer--;                       // |C^[P
        *buffer = (data % 10) + '0';    // ̌l𕶎ɂĊi[
        data = data / 10;               // -1
    }
}
/***************************************
* longASCIIɕϊ
****************************************/
void ltostring(unsigned char digit, unsigned long data, unsigned char *buffer){
    unsigned char i;

    buffer += digit;                        // Ō̐ʒu
    for(i=digit; i>0; i--) {                // ϊ͉ʂʂ
        buffer--;                           // |C^[P
        *buffer = (data % 10) + '0';        // ASCII
        data = data / 10;                   // ̌
    }
}
/***********************************
* Float當֕ϊ
* vL8ȉƂ邱
***********************************/
void ftostring(int seisu, int shousu, double data, unsigned char *buffer)
{
    int i;
    long dumy;

    if(shousu != 0)                         //肩
        buffer += seisu+shousu+1;           //Š{_
    else                                    //Ȃ̂Ƃ
        buffer += seisu + shousu;           //Š̂
    buffer--;                               //z|C^-1
    for(i=0; i<shousu; i++)                 //𐮐ɕϊ
        data = data * 10;                   //PO{
    /* dumyI[o[t[ƕϊs(WE) */
    dumy = (long) (data + 0.5);             //ľܓĐɕϊ
    for(i=shousu; i>0; i--) {               //JԂ
        *buffer =(dumy % 10)+'0';           //l𕶎ɕϊi[
        buffer--;                           //i[ꏊʂʂ
        dumy /= 10;                         //̌
    }
    if(shousu != 0) {                       //0Ȃ珬_Ȃ
        *buffer = '.';                      //_i[
        buffer--;                           //|C^-1
    }
    for(i=seisu; i>0; i--) {                //JԂ
        *buffer = (dumy % 10)+'0';          //l𕶎ɕϊi[
        buffer--;                           //|C^-1
        dumy /= 10;                         //̌
    }
}
    